LeetCode 198:House Robber

You are a professional robber planning to rob houses along a street. Each house has a certain amount of money stashed, the only constraint stopping you from robbing each of them is that adjacent houses have security system connected and it will automatically contact the police if two adjacent houses were broken into on the same night.

Given a list of non-negative integers representing the amount of money of each house, determine the maximum amount of money you can rob tonight without alerting the police.

Credits:
Special thanks to @ifanchu for adding this problem and creating all test cases. Also thanks to @ts for adding additional test cases.

//题目描写叙述:你是一名专业强盗,计划沿着一条街打家劫舍。

每间房屋都储存有一定数量的金钱,唯一能阻止你打劫的约束条件就是: //因为房屋之间有安全系统相连,假设同一个晚上有两间相邻的房屋被闯入。它们就会自己主动联络警察,因此不能够打劫相邻的房屋。 //给定一列非负整数,代表每间房屋的金钱数。计算出在不惊动警察的前提下一晚上最多能够打劫到的金钱数。 //解题思路: //对于第i个房间我们的选择是偷和不偷。 假设决定是偷 则第i-1个房间必须不偷 那么 这一步的就是 dp[i] = nums(i-1) + dpNotTake[i -1] , 假设dp[i]表示打劫到第i间房屋时累计取得的金钱最大值. //假设是不偷, 那么上一步就无所谓是不是已经偷过, dp[i] = dp[i -1 ]。 因此 dp[i] =max(dpNotTake[i-1 ] + nums(i-1), dp[i-1] ); 当中dpNotTake[i-1]=dp[i-2] //利用动态规划。状态转移方程:dp[i] = max(dp[i - 1], dp[i - 2] + num[i - 1]) //当中,dp[i]表示打劫到第i间房屋时累计取得的金钱最大值。 class Solution { public: int rob(vector<int>& nums) { int n = nums.size(); if (n == 0) return 0; int* dp = new int[n + 1]; dp[0] = 0; dp[1] = nums[0]; for (int i = 2; i < n + 1; ++i){ dp[i] = max(dp[i - 1], dp[i - 2] + nums[i - 1]); } return dp[n]; } };



posted @ 2017-08-05 09:39  wzjhoutai  阅读(114)  评论(0编辑  收藏  举报